chrome.tabs.onUpdated.addListener(function(tabId, changeInfo, tab) {
	var url = tab.url;

	if (! /^https?.*$/.test(url)) {
		return;
	}

	function cl(data) {
		return console.log(data);
	}

	var data = {};
	data.host = get_hostname(url);

	function load_everything(data_exported) {
		var settings_css = '';
		if(typeof data_exported[data.host].css !== "undefined") {
			settings_css = data_exported[data.host].css;
			if(settings_css != '') {
				chrome.tabs.insertCSS(tabId, {code: settings_css, runAt: 'document_start' });
			}
		}
		var settings_js = '';
		if(typeof data_exported[data.host].js !== "undefined") {
			settings_js = data_exported[data.host].js;
			if(settings_js != '') {
				chrome.tabs.executeScript(tabId,	{ file: "jquery.js", runAt: 'document_start' }, function () {
					chrome.tabs.executeScript(tabId,
						{ code: '$(document).ready(function() {' + stylerTestsScript(settings_js, data.host) + '})', runAt: 'document_start' }
						);
				});
			}
		}
	}

	chrome.storage.sync.get(data.host, function(settings) {
		chrome.storage.local.get(data.host, function(backup) {
			var data_exported = Object.assign(settings, backup);
			if(typeof data_exported[data.host] !== "undefined") {
				if(typeof data_exported[data.host].disable !== "undefined") {
					if(data_exported[data.host].disable == 1) {
						return;
					} else {
						load_everything(data_exported);
					}
				} else {
					load_everything(data_exported);
				}
			} else {
				cl('No settings');
			}
		});
	});

});


function save_background(deferred) {
	if (deferred.host) {
		save_settings(deferred.host, deferred.settings);
	}
}